package java.security;

import java.io.IOException;
import java.security.spec.InvalidParameterSpecException;
import java.security.spec.AlgorithmParameterSpec;

public abstract class AlgorithmParametersSpi
{
    public AlgorithmParametersSpi() {
    }
    
    protected abstract void engineInit(AlgorithmParameterSpec p0) throws InvalidParameterSpecException;
    
    protected abstract void engineInit(byte[] p0) throws IOException;
    
    protected abstract void engineInit(byte[] p0, String p1) throws IOException;
    
    protected abstract <T extends AlgorithmParameterSpec> T engineGetParameterSpec(Class<T> p0) throws InvalidParameterSpecException;
    
    protected abstract byte[] engineGetEncoded() throws IOException;
    
    protected abstract byte[] engineGetEncoded(String p0) throws IOException;
    
    protected abstract String engineToString();
}
